<?php

include_once(QLTGM_PLUGIN_DIR . 'includes/helpers.php');

class QLTGM_Settings {

  protected static $instance;

  // fix required header in license tab
  function settings_header()
  {
    global $submenu;
    include (QLTGM_PLUGIN_DIR . '/includes/view/backend/pages/parts/header.php');
  }

  // fix settings override with defaults on license save
  function settings_sanitize($qltgm) {

    $current = get_option(QLTGM_DOMAIN, array());

    return wp_parse_args($qltgm, $current);
  }

  // required to save license
  function settings_register() {
    register_setting(sanitize_key(QLTGM_DOMAIN . '-group'), sanitize_key(QLTGM_DOMAIN), array($this, 'settings_sanitize'));
  }

  function premium_version() {
    global $qltgm;
    //includes
    include_once(QLTGM_PLUGIN_DIR . 'includes/models/QLTGM_Model.php');
    include_once(QLTGM_PLUGIN_DIR . 'includes/models/Button.php');
    include_once(QLTGM_PLUGIN_DIR . 'includes/models/Box.php');
    include_once(QLTGM_PLUGIN_DIR . 'includes/models/Contact.php');
    include_once(QLTGM_PLUGIN_DIR . 'includes/models/Chat.php');
    include_once(QLTGM_PLUGIN_DIR . 'includes/models/Display.php');
    include_once(QLTGM_PLUGIN_DIR . 'includes/models/License.php');
    include_once(QLTGM_PLUGIN_DIR . 'includes/models/Scheme.php');
    // models
    $model = new QLTGM_Model();
    $license_model = new QLTGM_License();
    $button_model = new QLTGM_Button();
    $box_model = new QLTGM_Box();
    $contact_model = new QLTGM_Contact();
    $chat_model = new QLTGM_Chat();
    $display_model = new QLTGM_Display();
    $scheme_model = new QLTGM_Scheme();

    // objects
    $qltgm = $model->options();
    $qltgm['button'] = $button_model->get();
    $qltgm['box'] = $box_model->get();
    $qltgm['contacts'] = $contact_model->get_contacts_reorder();
    $qltgm['chat'] = $chat_model->get();
    $qltgm['display'] = $display_model->get();
    $qltgm['license'] = $license_model->get();
    $qltgm['scheme'] = $scheme_model->get();


    if (!is_admin()) {
    /*   if (isset($qltgm['button']['phone'])) {
        $qltgm['button']['phone'] = qltgm_format_phone($qltgm['button']['phone']);
      } */
      if (isset($qltgm['button']['timezone'])) {
        $qltgm['button']['timezone'] = qltgm_get_timezone_offset($qltgm['button']['timezone']);
      }
    }

    if (isset($qltgm['contacts'])) {
      if (count($qltgm['contacts'])) {
        foreach ($qltgm['contacts'] as $id => $c) {
          $qltgm['contacts'][$id] = wp_parse_args($c, $contact_model->get_args());

          if (!is_admin()) {
        /*     if (!empty($qltgm['contacts'][$id]['phone'])) {
              $qltgm['contacts'][$id]['phone'] = qltgm_format_phone($qltgm['contacts'][$id]['phone']);
            } */
            if (!empty($qltgm['contacts'][$id]['timezone'])) {
              $qltgm['contacts'][$id]['timezone'] = qltgm_get_timezone_offset($qltgm['contacts'][$id]['timezone']);
            }
          }
        }
      }
    }
  }

  function init()
  {
    add_filter('init', array($this, 'premium_version'));
    add_action('admin_init', array($this, 'settings_register'));
  }

  public static function instance()
  {
    if (!isset(self::$instance)) {
      self::$instance = new self();
      self::$instance->init();
    }
    return self::$instance;
  }
}

QLTGM_Settings::instance();

